ServerEvents.recipes(event => { //listen for the "recipes" server event.
    // You can replace `event` with any name you like, as 
    // long as you change it inside the callback too!
    
    // This part, inside the curly braces, is the callback.
    // You can modify as many recipes as you like in here,
    // without needing to use ServerEvents.recipes() again.
    event.replaceInput(
      { input: 'minecraft:wooden_shovel' },
      'minecraft:wooden_shovel',
      '#minecraft:shovels' 
    )
    event.replaceInput(
      { input: 'minecraft:wooden_axe' },
      'minecraft:wooden_axe',
      '#minecraft:axes' 
    )
    event.replaceInput(
      { input: 'minecraft:wooden_sword' },
      'minecraft:wooden_sword',
      '#minecraft:swords' 
    )
    event.replaceInput(
      { input: 'minecraft:wooden_pickaxe' },
      'minecraft:wooden_pickaxe',
      '#minecraft:pickaxes'
    )
    event.replaceInput(
      { input: 'minecraft:wooden_hoe' },
      'minecraft:wooden_hoe',
      '#minecraft:hoes' 
    )
    event.shaped(
        Item.of('mcwwindows:bamboo_shutter',), // arg 1: output
        [ 
          ' BB', 
          ' BB', // arg 2: the shape (array of strings)
          ' BB'  
        ],
        {
          B: 'minecraft:bamboo',   
        })
      event.shaped(
        Item.of('eidolon:silver_chestplate',), // arg 1: output
        [ 
          'A A', 
          'ABA', // arg 2: the shape (array of strings)
          'AAA'  
        ],
        {
          A: 'eidolon:silver_ingot',
          B: 'eidolon:silver_nugget'
        })
        event.shaped(
          Item.of('eidolon:silver_leggings',), // arg 1: output
          [ 
            'ABA', 
            'A A', // arg 2: the shape (array of strings)
            'A A'  
          ],
          {
            A: 'eidolon:silver_ingot',
            B: 'eidolon:silver_nugget'
          })
          event.shaped(
            Item.of('eidolon:silver_helmet',), // arg 1: output
            [ 
              'ABA', 
              'A A', // arg 2: the shape (array of strings)
              '   '  
            ],
            {
              A: 'eidolon:silver_ingot',
              B: 'eidolon:silver_nugget'
            })
            event.shaped(
              Item.of('eidolon:silver_boots',), // arg 1: output
              [ 
                'B B', 
                'A A', // arg 2: the shape (array of strings)
                '   '  
              ],
              {
                A: 'eidolon:silver_ingot',
                B: 'eidolon:silver_nugget'
              })
              event.shaped(
                Item.of('eidolon:silver_sword',), // arg 1: output
                [ 
                  ' B ', 
                  ' A ', // arg 2: the shape (array of strings)
                  ' C '  
                ],
                {
                  A: 'eidolon:silver_ingot',
                  B: 'eidolon:silver_nugget',
                  C: 'minecraft:stick'
                })
                event.shaped(
                  Item.of('eidolon:silver_pickaxe',), // arg 1: output
                  [ 
                    'ABA', 
                    ' C ', // arg 2: the shape (array of strings)
                    ' C '  
                  ],
                  {
                    A: 'eidolon:silver_ingot',
                    B: 'eidolon:silver_nugget',
                    C: 'minecraft:stick'
                  })
                  event.shaped(
                    Item.of('eidolon:silver_axe',), // arg 1: output
                    [ 
                      ' AB', 
                      ' CA', // arg 2: the shape (array of strings)
                      ' C '  
                    ],
                    {
                      A: 'eidolon:silver_ingot',
                      B: 'eidolon:silver_nugget',
                      C: 'minecraft:stick'
                    })
                    event.shaped(
                      Item.of('eidolon:silver_shovel',), // arg 1: output
                      [ 
                        ' B ', 
                        ' C ', // arg 2: the shape (array of strings)
                        ' C '  
                      ],
                      {
                        B: 'eidolon:silver_nugget',
                        C: 'minecraft:stick'
                      })
                      event.shaped(
                        Item.of('eidolon:silver_hoe',), // arg 1: output
                        [ 
                          ' AB', 
                          ' C ', // arg 2: the shape (array of strings)
                          ' C '  
                        ],
                        {
                          A: 'eidolon:silver_ingot',
                          B: 'eidolon:silver_nugget',
                          C: 'minecraft:stick'
                        })
        event.remove({id: 'mcwwindows:bamboo_shutter'})

          event.shaped(
            Item.of('untamedwilds:debug_analyzer',), // arg 1: output
            [ 
              'FEF', 
              'EDE', // arg 2: the shape (array of strings)
              'AEA'  
            ],
            {
              A: 'minecraft:iron_ingot',
              D: 'minecraft:nether_star',
              E: 'minecraft:glass',
              F: 'untamedwilds:flora_common_reed',   
            })
            event.shaped(
              Item.of('weaponmaster:weaponkit',), // arg 1: output
              [ 
                'FEF', 
                'EDE', // arg 2: the shape (array of strings)
                'AEA'  
              ],
              {
                A: 'minecraft:stick',
                D: 'atlas:core',
                E: 'minecraft:iron_ingot',
                F: '#forge:leather',   
              })
            event.shapeless('4x minecraft:oak_planks', [ // arg 1: output
            '#minecraft:oak_logs'
          ])
          event.shapeless('4x spelunkers_charm:rock', [ // arg 1: output
          'minecraft:cobblestone'
        ])
        event.shapeless('4x spelunkers_charm:deepslate_rock', [ // arg 1: output
        'minecraft:cobbled_deepslate'
      ])
      event.shapeless('4x spelunkers_charm:dripstone_rock', [ // arg 1: output
      'minecraft:dripstone_block'
    ])
    event.shapeless('4x spelunkers_charm:basalt_rock', [ // arg 1: output
    'minecraft:basalt'
  ])
            event.shapeless('4x minecraft:spruce_planks', [ // arg 1: oeutput
            '#minecraft:spruce_logs'
          ])
            event.shapeless('4x minecraft:birch_planks', [ // arg 1: output
          '#minecraft:birch_logs'
          ])
            event.shapeless('4x minecraft:acacia_planks', [ // arg 1: output
          '#minecraft:acacia_logs'
          ])  
           event.shapeless('4x minecraft:dark_oak_planks', [ // arg 1: output
          '#minecraft:dark_oak_logs'
          ])
           event.shapeless('4x minecraft:mangrove_planks', [ // arg 1: output
            '#minecraft:mangrove_logs'
          ])
          event.shapeless('4x minecraft:cherry_planks', [ // arg 1: output
          '#minecraft:cherry_logs'
          ])
          event.shapeless('4x minecraft:jungle_planks', [ // arg 1: output
            '#minecraft:jungle_logs'
          ])
          event.remove({id: 'weaponmaster:weaponkit'})
          event.remove({id: 'depthcrawler:whiteblast_2'})
          event.remove({id: 'undead_revamp2:chainedswords'})
          event.remove({id: 'enemyexpansion:phantasm_boots'})
          event.remove({id: 'enemyexpansion:phantasm_leggings'})
          event.remove({id: 'enemyexpansion:phantasm_chestplate'})
          event.remove({id: 'eidolon:raven_cloak'})
          event.remove({id: 'iceandfire:dragon_meal'})
          event.remove({id: 'create_sa:quartz_gem_crushing'})
          event.remove({id: 'eidolon:silver_leggings'})
          event.remove({id: 'eidolon:silver_boots'})
          event.remove({id: 'eidolon:silver_chestplate'})
          event.remove({id: 'eidolon:silver_helmet'})
          event.remove({id: 'eidolon:silver_hoe'})
          event.remove({id: 'eidolon:silver_shovel'})
          event.remove({id: 'eidolon:silver_axe'})
          event.remove({id: 'eidolon:silver_pickaxe'})
          event.remove({id: 'eidolon:silver_sword'})
          event.remove({id: 'iceandfire:silver_ingot_from_smelting_raw_silver'})
          event.remove({id: 'iceandfire:silver_ingot_from_blasting_raw_silver'})
          event.remove({id: 'iceandfire:furnace/silver_nugget'})
          event.remove({id: 'iceandfire:furnace/silver_nugget_blasting'})
          event.remove({id: 'iceandfire:silver_nugget_to_silver_ingot'})
          event.remove({id: 'iceandfire:raw_silver_block_to_raw_silver'})
          event.remove({id: 'iceandfire:silver_block_to_silver_ingot'})
          event.remove({id: 'iceandfire:raw_silver_to_raw_silver_block'})
          event.remove({id: 'iceandfire:silver_ingot_to_silver_block'})
          event.remove({id: 'iceandfire:silver_ingot_to_silver_nugget'})
          event.remove({id: 'epicsamurai:ingot_silver_compat_create_smelting'})
          event.remove({id: 'epicsamurai:ingot_silver_compat_create_blasting'})
          event.remove({id: 'epicsamurai:silver_ingot_from_smelting_raw_silver'})
          event.remove({id: 'epicsamurai:silver_ingot_from_nugget'})
          event.remove({id: 'epicsamurai:silver_ingot_from_blasting_raw_silver'})
          event.remove({id: 'iceandfire:silver_ingot_from_nugget'})
          event.remove({id: 'epicsamurai:silver_nugget_create_washing'})
          event.remove({id: 'epicsamurai:silver_nugget'})
          event.remove({id: 'iceandfire:silver_ingot'})
          event.remove({id: 'epicsamurai:silver_ingot'})
          event.remove({id: 'iceandfire:silver_block'})
          event.remove({id: 'epicsamurai:silver_block'})
          event.remove({id: 'epicsamurai:silver_ingot_from_smelting_deepslate_silver_ore'})
          event.remove({id: 'epicsamurai:silver_ingot_from_smelting_silver_ore'})
          event.remove({id: 'epicsamurai:silver_ingot_from_blasting_deepslate_silver_ore'})
          event.remove({id: 'epicsamurai:silver_ingot_from_blasting_silver_ore'})
          event.remove({id: 'iceandfire:furnace/silver_ingot_blasting'})
          event.remove({id: 'iceandfire:furnace/silver_ingot'})
          event.remove({id: 'iceandfire:furnace/silver_ingot_blasting'})
          event.remove({id: 'iceandfire:furnace/deepslate_silver_ingot'})
          event.remove({id: 'iceandfire:furnace/deepslate_silver_ingot_blasting'})
          event.remove({id: 'moltenmetal:heavy_golden_chest_plate'})
          event.remove({id: 'moltenmetal:heavy_golden_helmet'})
          event.remove({id: 'moltenmetal:heavy_netherite_chestplate'})
          event.remove({id: 'moltenmetal:heavy_netherite_helmet'})
          event.remove({id: 'moltenmetal:heavy_diamond_chest_plate'})
          event.remove({id: 'moltenmetal:heavy_diamond_helmet'})
          event.remove({id: 'moltenmetal:heavy_iron_chest_piece'})
          event.remove({id: 'moltenmetal:heavy_iron_helmet'})
          event.remove({id: 'iceandfire:ambrosia'})
          event.remove({id: 'create:crafting/kinetics/cart_assembler'})
          event.remove({id: 'fabledweaponry:mace_stone'})
          event.remove({id: 'fabledweaponry:mace_wood'})
          event.remove({id: 'fabledweaponry:scimitar_stone'})
          event.remove({id: 'fabledweaponry:scimitar_wood'})
          event.remove({id: 'fabledweaponry:dagger_stone'})
          event.remove({id: 'fabledweaponry:dagger_wood'})
          event.remove({id: 'fabledweaponry:scythe_stone'})
          event.remove({id: 'fabledweaponry:scythe_wood'})
          event.remove({id: 'fabledweaponry:maul_stone'})
          event.remove({id: 'fabledweaponry:maul_wood'})
          event.remove({id: 'fabledweaponry:waraxe_stone'})
          event.remove({id: 'fabledweaponry:waraxe_wood'})
          event.remove({id: 'fabledweaponry:greatsword_stone'})
          event.remove({id: 'fabledweaponry:greatsword_wood'})
          event.remove({id: 'minecraft:stone_hoe'})
          event.remove({id: 'minecraft:stone_sword'})
          event.remove({id: 'minecraft:stone_shovel'})
          event.remove({id: 'minecraft:stone_pickaxe'})
          event.remove({id: 'minecraft:stone_axe'})
          event.remove({id: 'minecraft:wooden_hoe'})
          event.remove({id: 'minecraft:wooden_sword'})
          event.remove({id: 'minecraft:wooden_shovel'})
          event.remove({id: 'minecraft:wooden_pickaxe'})
          event.remove({id: 'minecraft:wooden_axe'})
          event.remove({id: 'supplementaries:cage'})
          event.remove({id: 'create_sa:copper_propeler_recipe'})
          event.remove({id: 'create_sa:andesite_jetpack_recipe'})
          event.remove({id: 'create_sa:brass_jetpack_recipe'})
          event.remove({id: 'candlelight:gold_ring'})
          event.remove({id: 'gnumus:lucky_hat_k'})
          event.remove({id: 'simpleradio:radio'})
          event.remove({id: 'simpleradio:transceiver'})
          event.remove({id: 'simpleradio:transmitting_module'})
          event.remove({id: 'simpleradio:receiving_module'})
          event.remove({id: 'simpleradio:speaker_module'})
          event.remove({id: 'beachparty:radio'})
          event.remove({id: 'framedblocks:framed_cube'})
          event.remove({id: 'endermanoverhaul:corrupted_shield'})
          event.remove({id: 'endermanoverhaul:corrupted_blade'})
          event.remove({id: 'endermanoverhaul:enderman_tooth'})
          event.remove({id: 'framedblocks:framed_slope'})
          event.remove({id: 'framedblocks:framed_corner_slope'})
          event.remove({id: 'framedblocks:framed_inner_corner_slope'})
          event.remove({id: 'framedblocks:framed_prism_corner'})
          event.remove({id: 'framedblocks:framed_inner_prism_corner'})
          event.remove({id: 'framedblocks:framed_threeway_corner'})
          event.remove({id: 'framedblocks:framed_inner_threeway_corner'})
          event.remove({id: 'framedblocks:framed_double_slope'})
          event.remove({id: 'framedblocks:framed_double_corner'})
          event.remove({id: 'framedblocks:framed_double_prism_corner'})
          event.remove({id: 'framedblocks:framed_double_threeway_corner'})
          event.remove({id: 'framedblocks:framed_horizontal_pane'})
          event.remove({id: 'framedblocks:framed_rail_slope'})
          event.remove({id: 'framedblocks:framed_powered_rail_slope'})
          event.remove({id: 'framedblocks:framed_detector_rail_slope'})
          event.remove({id: 'framedblocks:framed_activator_rail_slope'})
          event.remove({id: 'framedblocks:framed_prism'})
          event.remove({id: 'framedblocks:framed_inner_prism'})
          event.remove({id: 'framedblocks:framed_double_prism'})
          event.remove({id: 'framedblocks:framed_sloped_prism'})
          event.remove({id: 'framedblocks:framed_inner_sloped_prism'})
          event.remove({id: 'framedblocks:framed_double_sloped_prism'})
          event.remove({id: 'framedblocks:framed_sloped_slab'})
          event.remove({id: 'framedblocks:framed_elevated_slope_slab'})
          event.remove({id: 'framedblocks:framed_double_slope_slab'})
          event.remove({id: 'framedblocks:framed_inv_double_slope_slab'})
          event.remove({id: 'framedblocks:framed_elevated_double_slope_slab'})
          event.remove({id: 'framedblocks:framed_stacked_slope_slab'})
          event.remove({id: 'framedblocks:framed_flat_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_elev_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_inner_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_elev_inner_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_double_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_inv_double_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_elev_double_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_elev_inner_double_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_stacked_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_stacked_inner_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_slope_panel'})
          event.remove({id: 'framedblocks:framed_extended_slope_panel'})
          event.remove({id: 'framedblocks:framed_double_slope_panel'})
          event.remove({id: 'framedblocks:framed_inv_double_slope_panel'})
          event.remove({id: 'framedblocks:framed_slope_extended_double_panel'})
          event.remove({id: 'framedblocks:framed_stacked_slope_panel'})
          event.remove({id: 'framedblocks:framed_flat_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_inner_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_ext_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_ext_inner_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_ext_double_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_ext_inner_double_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_stacked_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_stacked_inner_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_small_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_large_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_small_inner_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_large_inner_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_ext_inner_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_ext_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_small_double_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_large_double_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_inv_double_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_ext_double_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_ext_inner_double_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_stacked_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_stacked_inner_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_pyramid'})
          event.remove({id: 'framedblocks:framed_pyramid_slab'})
          event.remove({id: 'framedblocks:framed_target'})
          event.remove({id: 'framedblocks:framed_fancy_rail'})
          event.remove({id: 'framedblocks:framed_fancy_powered_rail'})
          event.remove({id: 'framedblocks:framed_fancy_detector_rail'})
          event.remove({id: 'framedblocks:framed_fancy_activator_rail'})
          event.remove({id: 'framedblocks:framed_fancy_rail_slope'})
          event.remove({id: 'framedblocks:framed_fancy_powered_rail_slope'})
          event.remove({id: 'framedblocks:framed_fancy_detector_rail_slope'})
          event.remove({id: 'framedblocks:framed_fancy_activator_rail_slope'})
          event.remove({id: 'framedblocks:framed_half_slope'})
          event.remove({id: 'framedblocks:framed_divided_slope'})
          event.remove({id: 'framedblocks:framed_double_half_slope'})
          event.remove({id: 'framedblocks:framed_sloped_stairs'})
          event.remove({id: 'framedblocks:framed_vertical_sloped_stairs'})
          event.remove({id: 'framedblocks:framed_one_way_window'})
          event.remove({id: 'framedblocks:framing_saw'})
          event.remove({id: 'framedblocks:powered_framing_saw'})
          event.remove({id: 'epicsamurai:tanegashima'})
          event.remove({id: 'epicsamurai:bullet'})
          event.remove({id: 'epicsamurai:bullets'})
          event.remove({id: 'butcher:reversedragonscaleblockrecipe'})
          event.remove({id: 'butcher:dragonscaleingotrecipe'})
          event.remove({id: 'butcher:dragonsmithingtemplate'})
          event.remove({id: 'butcher:reversedragonscaleblockrecipe'})
          event.shaped(
            Item.of('4x framedblocks:framed_fence',), // arg 1: output
            [ 
              '   ', 
              'ABA', // arg 2: the shape (array of strings)
              'ABA'  
            ],
            { 
              A: 'framedblocks:framed_cube',
              B: 'minecraft:stick',   
            })
            event.shaped(
              Item.of('4x framedblocks:framed_pillar',), // arg 1: output
              [ 
                '   ', 
                ' A ', // arg 2: the shape (array of strings)
                ' A '  
              ],
              { 
                A: 'framedblocks:framed_cube',   
              })


                event.shaped(
                  Item.of('4x framedblocks:framed_cube',), // arg 1: output
                  [ 
                    'BBB', 
                    'B B', // arg 2: the shape (array of strings)
                    'BBB'  
                  ],
                  { 
                    B: 'minecraft:stick',   
                  })
     event.shaped(
       Item.of('4x alexscaves:rusty_scrap_metal',), // arg 1: output
         [ 
          ' A ', 
          'ABA', // arg 2: the shape (array of strings)
          ' A '  
          ],
          {
          A: 'minecraft:copper_ingot',
          B: 'minecraft:iron_ingot'
         })
         event.shaped(
          Item.of('4x alexscaves:rusty_rebar',), // arg 1: output
            [ 
             ' A ', 
             ' A ', // arg 2: the shape (array of strings)
             '   '  
             ],
             {
             A: 'alexscaves:rusty_scrap_metal'
            })
            event.shaped(
              Item.of('16x alexscaves:rusty_scaffolding',), // arg 1: output
                [ 
                 'AAA', 
                 'B B', // arg 2: the shape (array of strings)
                 'B B'  
                 ],
                 {
                 A: 'alexscaves:rusty_scrap_metal',
                 B: 'alexscaves:rusty_rebar'
                })
                event.shaped(
                  Item.of('alexscaves:rusty_barrel',), // arg 1: output
                    [ 
                     ' A ', 
                     ' B ', // arg 2: the shape (array of strings)
                     '   '  
                     ],
                     {
                     A: 'alexscaves:rusty_scrap_metal',
                     B: 'minecraft:barrel'
                    })
event.campfireCooking('atlas:feraille_fondu', 'atlas:scrap_metal')
event.shaped('1x atlas:prisonkey', [// arg 1: output
    'AA ', 
    'AA ', // arg 2: the shape (array of strings)
    '  A'  
  ], {
    A: 'atlas:feraille_fondu',   
  }
)
})

